SystemOrganization addCategory: #Reflectogram!
SystemOrganization addCategory: 'Reflectogram-Benchmarks'!
SystemOrganization addCategory: 'Reflectogram-Case-Study'!
SystemOrganization addCategory: 'Reflectogram-Conditions-Actions'!
SystemOrganization addCategory: 'Reflectogram-Events'!
SystemOrganization addCategory: 'Reflectogram-Graph-Points'!
SystemOrganization addCategory: 'Reflectogram-Modes'!
SystemOrganization addCategory: 'Reflectogram-Targets'!

BlockClosure variableSubclass: #MetaAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Conditions-Actions'!

MetaAction variableSubclass: #FrameworkMetaAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Conditions-Actions'!

MetaAction variableSubclass: #UserMetaAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Conditions-Actions'!

BlockClosure variableSubclass: #MetaCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Conditions-Actions'!

MetaCondition variableSubclass: #FrameworkMetaCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Conditions-Actions'!

MetaCondition variableSubclass: #InstallationMetaCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Conditions-Actions'!

MetaCondition variableSubclass: #UserMetaCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Conditions-Actions'!

Object subclass: #BenchAll
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Benchmarks'!

Object subclass: #Event
	uses: TRBProgramNodeVisitor
	instanceVariableNames: 'link'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

Event class
	uses: TRBProgramNodeVisitor classTrait
	instanceVariableNames: 'default'!

Event class
	uses: TRBProgramNodeVisitor classTrait
	instanceVariableNames: 'default'!

!Event methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 18:08'!
annotateMethod: aMethod withLink: aMetaLink 

	link := aMetaLink.
	self visitNode: aMethod ast! !

!Event methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 15:36'!
resolveScopeFor: aTarget

	self subclassResponsibility ! !

!Event methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 20:08'!
scope

	self subclassResponsibility ! !

Event subclass: #MultiScopedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!MultiScopedEvent methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 20:11'!
scope

	^ MultiScoped! !

MultiScopedEvent subclass: #RealMultiScoped
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

RealMultiScoped subclass: #PassedAsArg
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!PassedAsArg methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 20:04'!
visitMessageNode: aMessageNode 
	aMessageNode link: link.
	^ super visitMessageNode: aMessageNode.! !

!RealMultiScoped methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 16:01'!
resolveScopeFor: aTarget

	aTarget realMultiScopedEvent: self! !

!RealMultiScoped methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 15:59'!
scope

	^ RealMultiScope ! !

RealMultiScoped subclass: #Returned
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!Returned methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 20:04'!
visitReturnNode: aReturnNode 
	aReturnNode link: link.
	^ super visitReturnNode: aReturnNode.! !

RealMultiScoped subclass: #Stored
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!Stored methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 20:06'!
visitAssignmentNode: anAssignmentNode
	anAssignmentNode link: link.
	^ super visitAssignmentNode: link.! !

!Stored methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 18:05'!
visitStoreIntoTempNode: aNode
	^ aNode! !

MultiScopedEvent subclass: #SimulatedMultiScoped
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

SimulatedMultiScoped subclass: #MSGReceive
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!MSGReceive methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 20:00'!
visitMessageNode: aMessageNode 
	aMessageNode link: link.
	^ super visitMessageNode: aMessageNode.! !

SimulatedMultiScoped subclass: #ObjectCreation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!ObjectCreation methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 20:03'!
visitMethodNode: aMethodNode 
	aMethodNode link: link.
	^ super visitMethodNode: aMethodNode.! !

!SimulatedMultiScoped methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 16:01'!
resolveScopeFor: aTarget

	aTarget simulatedMultiScopedEvent: self! !

!SimulatedMultiScoped methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 15:59'!
scope

	^ SimulatedMultiScope ! !

Event subclass: #SingleScopedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

SingleScopedEvent subclass: #IVRead
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!IVRead methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 18:12'!
visitVariableNode: aVariableNode
	aVariableNode link: link.
	^ super visitVariableNode: aVariableNode.! !

SingleScopedEvent subclass: #IVWrite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!IVWrite methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 18:12'!
visitAssignmentNode: anAssignmentNode
	anAssignmentNode link: link.
	^ super visitAssignmentNode: anAssignmentNode.! !

SingleScopedEvent subclass: #MSGSend
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!MSGSend methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 18:14'!
visitMessageNode: aMessageNode 
	aMessageNode link: link.
	^ super visitMessageNode: aMessageNode.! !

SingleScopedEvent subclass: #MethodExecution
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!MethodExecution methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 18:36'!
visitMethodNode: aMethodNode 
	aMethodNode link: link.
	^ super visitMethodNode: aMethodNode.! !

SingleScopedEvent subclass: #Return
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!Return methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 18:38'!
visitReturnNode: aReturnNode 

		aReturnNode link: link.
		^ super visitReturnNode: aReturnNode.! !

!SingleScopedEvent methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 15:36'!
resolveScopeFor: aTarget

	aTarget singleScopedEvent: self.! !

!SingleScopedEvent methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 20:11'!
scope

	^ SingleScoped! !

SingleScopedEvent subclass: #TempRead
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!TempRead methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 18:48'!
visitTemporaryNode: aNode 
	"Sent *each time* a temporary node is found"
	aNode link: link.
	^ super visitTemporaryNode: aNode.! !

SingleScopedEvent subclass: #TempStore
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!TempStore methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 18:50'!
visitStoreIntoTempNode: aNode
	aNode link: link.
	^ super visitStoreIntoTempNode: aNode.! !

Object subclass: #Mode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Mode subclass: #Scope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Scope subclass: #MultiScoped
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

MultiScoped subclass: #RealMultiScope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

MultiScoped subclass: #SimulatedMultiScope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Scope subclass: #SingleScoped
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

SingleScoped subclass: #LexicallyScoped
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

SingleScoped subclass: #RunTimeScoped
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Mode subclass: #Semantics
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

!Semantics commentStamp: 'NickPapoulias 7/23/2015 19:16' prior: 0!
semantics of hierarchy and reification!

Semantics subclass: #Hierarchy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Hierarchy subclass: #Flat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Hierarchy subclass: #Inheritance
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Semantics subclass: #Reification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Reification subclass: #Entity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Reification subclass: #Instance
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Object subclass: #Reflectogram
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Graph-Points'!

!Reflectogram class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/25/2015 13:19'!
on: anEntity as: semanticsPair for: anEvent limitedTo: installationCondition when: userCondition do: userAction

	"single methods can be treated through class -- same for contexts"
	
	| reification inheritance target |
	
	reification := semanticsPair key. "Instance -> Flat etc"
	inheritance := semanticsPair value.
	
	target := (reification = Instance) "This can also be done with Target on:given: replicating here for clarity" 
		ifTrue: [ ^ ObjectTarget new target: anEntity  ] "treat as object"
		ifFalse: [ ^ (Target resolve: anEntity) new target: anEntity ]. "treat as entity -- which also includes objects"
	
	target 
		setScopeFor: anEvent; "major scope and sub scope"
		calculateAffectedMethodsGiven: inheritance; 
		limitAffectedMethodsGiven: installationCondition.
	
	target 
		affectedMethods do: [: method |  anEvent annotateMethod: method. "the event should know" ]
	 	! !

!Reflectogram class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/24/2015 10:18'!
on: anEntity for: anEvent limitedTo: installationCondition when: userCondition do: userAction

	"installation condition can be method | class | package"
	
	| defaultSemanticPair |
	defaultSemanticPair := anEntity defaultSemanticPair.! !

!Reflectogram class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/24/2015 10:47'!
on: anEntity for: anEvent when: userCondition do: userAction

	"installation condition can be method | class | package"
	
	| defaultSemanticPair |
	defaultSemanticPair := anEntity defaultSemanticPair.! !

Reflectogram subclass: #ReflectogramGraph
	instanceVariableNames: 'target event metaConditionGroup metaActionGroup trace points'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Graph-Points'!

Reflectogram subclass: #ReflectogramPoint
	instanceVariableNames: 'graph reifications time level'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Graph-Points'!

Object subclass: #ReflectogramVisualization
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Graph-Points'!

Object subclass: #Reifications
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Graph-Points'!

Object subclass: #Target
	instanceVariableNames: 'target scope inheritance reification'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Targets'!

Target class
	instanceVariableNames: 'resolveDict'!

Target class
	instanceVariableNames: 'resolveDict'!

Target subclass: #ClassTarget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Targets'!

!ClassTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 15:38'!
singleScopedEvent: anEvent

	scope := LexicallyScoped ! !

Target subclass: #ContextTarget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Targets'!

!ContextTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 15:40'!
singleScopedEvent: anEvent

	scope := RunTimeScoped ! !

Target subclass: #ImageTarget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Targets'!

!ImageTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 15:41'!
singleScopedEvent: anEvent

	scope := LexicallyScoped ! !

Target subclass: #MethodTarget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Targets'!

!MethodTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 15:41'!
singleScopedEvent: anEvent

	scope := LexicallyScoped ! !

Target subclass: #ObjectTarget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Targets'!

!ObjectTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 15:42'!
singleScopedEvent: anEvent

	scope := RunTimeScoped ! !

Target subclass: #PackageTarget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Targets'!

!PackageTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 15:42'!
singleScopedEvent: anEvent

	scope := LexicallyScoped ! !

Target subclass: #ProcessTarget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Targets'!

!ProcessTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 15:43'!
multiScopedEvent: anEvent

	self shouldNotImplement  ! !

!ProcessTarget methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/29/2015 15:43'!
singleScopedEvent: anEvent

	scope := RunTimeScoped ! !

!Target class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/25/2015 13:09'!
on: anEntity

	^ self on: anEntity given: Entity! !

!Target class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/25/2015 13:08'!
on: anEntity given: reification
	
	(reification = Instance) 
		ifTrue: [ ^ ObjectTarget new target: anEntity  ] "treat as object"
		ifFalse: [ ^ (Target resolve: anEntity) new target: anEntity ]. "treat as entity -- which also includes objects"	! !

!Target class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/25/2015 13:09'!
resolve: anEntity
	
	self resolveDict keysAndValuesDo: [ :classKey : targetClass |
		(anEntity class isKindOf: classKey) ifTrue: [ ^ targetClass ]		
	].

	^ ObjectTarget
	! !

!Target class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/25/2015 13:03'!
resolveDict
	
	^ resolveDict ifNil: [resolveDict := {Class -> ClassTarget . Context -> ContextTarget . SystemDictionary -> ImageTarget . CompiledMethod ->MethodTarget .RPackage -> PackageTarget . Process -> ProcessTarget} asDict]  
! !

!Target methodsFor: 'accessing' stamp: 'NickPapoulias 7/29/2015 16:02'!
realMultiScopedEvent: anEvent

	scope := anEvent scope! !

!Target methodsFor: 'accessing' stamp: 'NickPapoulias 7/29/2015 15:34'!
setScopeFor: anEvent

	anEvent resolveScopeFor: self class.! !

!Target methodsFor: 'accessing' stamp: 'NickPapoulias 7/29/2015 16:02'!
simulatedMultiScopedEvent: anEvent

	scope := anEvent scope! !

!Target methodsFor: 'accessing' stamp: 'NickPapoulias 7/29/2015 15:37'!
singleScopedEvent: anEvent

	self subclassResponsibility ! !

!Target methodsFor: 'accessing' stamp: 'NickPapoulias 7/23/2015 16:36'!
target
	^ target! !

!Target methodsFor: 'accessing' stamp: 'NickPapoulias 7/23/2015 16:36'!
target: anObject
	target := anObject! !

Object subclass: #WebApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Case-Study'!
